package com.ibm.rhapsody.customtables.samples;
import java.util.ArrayList;
import java.util.List;

import com.telelogic.rhapsody.core.IRPApplication;
import com.telelogic.rhapsody.core.IRPAttribute;
import com.telelogic.rhapsody.core.IRPClassifier;
import com.telelogic.rhapsody.core.IRPCollection;
import com.telelogic.rhapsody.core.IRPInstance;
import com.telelogic.rhapsody.core.IRPModelElement;
import com.telelogic.rhapsody.core.IRPProject;
import com.telelogic.rhapsody.core.RPUserPlugin;
import com.telelogic.rhapsody.core.RhapsodyAppServer;

/**
 * This is a combined Plugin and Main
 * As such the helper may be launched in either mode by changing the HEP file
 * @author Andy Lapping
 */

public class SampleTableFunctions extends RPUserPlugin {

	static IRPApplication rpApp;
	static IRPProject rpy;


	public static void main(String[] args) {
		rpApp = RhapsodyAppServer.getActiveRhapsodyApplication();
		rpy = rpApp.activeProject();
			
	}
	
	
	
	public static void getOwner(IRPModelElement elt, IRPCollection results) {
		IRPModelElement ref = elt.getOwner();
		if (ref != null)
			results.addItem(ref);
	}
	
	public static void getValueProperties(IRPModelElement elt, IRPCollection results) {
		/*
		 * Returns the value Properties 
		 */
		IRPInstance i = (IRPInstance) elt;
		IRPClassifier cls = i.getOtherClass();
		for (Object o:cls.getAttributes().toList()) {
			IRPAttribute a = (IRPAttribute) o;
			results.addItem(a);
		}
	}
	
	
	
	public void RhpPluginInit(IRPApplication rpyApplication) {
		SampleTableFunctions.rpApp = rpyApplication;
		RhapsodyAppServer.setLogFile("C:\\temp\\logfile.txt");
		rpApp.writeToOutputWindow(null, "Custom Cells Plugin Loaded");
	}

	public void OnMenuItemSelect(String menuItem) {
		//This method is called when the user invokes the helper from the right-click menu
	
	}
	
	public void RhpPluginInvokeItem() {
		//This method is called when the user invokes the helper from the tools menu
	
		
	}

	public void OnTrigger(String trigger) {
		//This method is called when the helper is invoked automatically by a trigger specified in the HEP file
		
	}

	public boolean RhpPluginCleanup() {
		// TODO Auto-generated method stub
		return false;
	}

	
	public void RhpPluginFinalCleanup() {
		// TODO Auto-generated method stub
		
	}



	
	


}
